#version 150

layout(points) in;

layout(triangle_strip, max_vertices = 4) out;



uniform mat4 mvMat;
uniform mat4 projMat;
uniform vec3 lightPos;

in vec2 params[1];

out vec2 texCoords;

void main(void)
{

	vec2 off;
	mat4 moveMatrix;
	
	float m = 2.0f;
	vec4 position = gl_in[0].gl_Position;
	float shape = params[0].x;
	float size = params[0].y;
	

	 vec4 lightScreen = projMat * mvMat * vec4(lightPos, 1);
	 lightScreen = lightScreen / lightScreen.w;
	 lightScreen.x *= -1;
	 lightScreen.y *= -1;
	 vec4 center = vec4(0,0,lightScreen.z, 1) ;
	float factor = position.x *4 ;
	vec4 step = (center- lightScreen) / 3.0f;

vec4 pos = lightScreen + step * (factor);

size /= clamp(max(lightScreen.x,lightScreen.y),0.3,1);
	
//	if (pos.x > -100)
//pos = vec4(lightScreen.x/lightScreen.w,lightScreen.y/lightScreen.w,0,1);

	off.x = float(1.0f/m) * float(mod(int(shape), int(m)));
	off.y = float(1.0f/m) * (1 - float(floor(shape/m)));


	moveMatrix[0] = vec4(1.0, 0.0, 0.0, 0.0);
	moveMatrix[1] = vec4(0.0, 1.0, 0.0, 0.0);
	moveMatrix[2] = vec4(0.0, 0.0, 1.0, 0.0);
	moveMatrix[3] = vec4(0.0, 0.0, 0.0, 1.0);
	

	moveMatrix[3] = vec4(-size/2, -size/2, 0, 1);
	gl_Position =  moveMatrix  * pos;
	texCoords = vec2(0 + off.x, -1*(0 + off.y));
	EmitVertex();
	
	moveMatrix[3] = vec4(size/2, -size/2, 0, 1);
	gl_Position = moveMatrix  * pos;
	texCoords = vec2(1.0f/m + off.x, -1*(0 + off.y));
	EmitVertex();	
	
	moveMatrix[3] = vec4(-size/2, size/2, 0, 1);
	gl_Position = moveMatrix  * pos;
	texCoords = vec2(0 + off.x, -1*(1.0f/m + off.y));
	EmitVertex();	
	
	moveMatrix[3] = vec4(size/2, size/2, 0, 1);
	gl_Position = moveMatrix  * pos;
	texCoords = vec2(1.0f/m + off.x, -1*(1.0f/m + off.y));
	EmitVertex();

	EndPrimitive();
    


}
