#version 150


in  vec3 in_Position;
in vec2 in_TexCoord;


out vec4 lightScreenCoords;
out vec4 lightWorldCoords;
out vec2 ex_fragTexCoord;

uniform mat4 mvMat;
uniform mat4 projMat;
uniform vec3 lightDirection;

void main(void)
{

	ex_fragTexCoord = in_TexCoord;
	mat4 bias = mat4( 0.5, 0.0, 0.0, 0.0,
					  0.0, 0.5, 0.0, 0.0,
					  0.0, 0.0, 0.5, 0.0,
					  0.5, 0.5, 0.5, 1.0 );
	//vec3 lightPos = vec3(-5, 5, -20);
	lightScreenCoords = bias * projMat * mvMat * vec4(lightDirection,1); //move coords to 0..1 range
	lightWorldCoords = mvMat * vec4(lightDirection,1);
	
	gl_Position = vec4(in_Position,1);
	
}
