// Vertex Shader â€“ file "minimal.vert"

#version 150 //SL version 2 not 4

uniform mat4 mvMat;
uniform mat4 projMat;
uniform vec3 color;

in  vec3 in_Position;
in  vec3 in_Position_Target; 

out vec3 ex_Color;

uniform int interpolate;
uniform float dt;

	
void main(void)
{

	vec3 position;

	if(interpolate == 1)
	{
		position.x = (1-dt) * in_Position.x + dt * in_Position_Target.x;
		position.y = (1-dt) * in_Position.y + dt * in_Position_Target.y;
		position.z = (1-dt) * in_Position.z + dt * in_Position_Target.z;
		
	}
	else
	{
		position = in_Position;
	}
	
	//position calculation
	gl_Position = projMat *  mvMat * vec4(position,1); 


	ex_Color = color;
	
	
}
