#version 150

layout(points) in;

layout(triangle_strip, max_vertices = 4) out;



uniform mat4 mvMat;
uniform mat4 projMat;
uniform vec3 lightDirection;


in vec3 normvelo[1];
in vec4 params[1];
in float geomAlpha[1];

out vec2 texCoords;
//out vec4 color;
//out vec3 light;
//out vec3 normal;
out float fragAlpha;
uniform float m; //sprite factor
uniform float updatetime;
uniform int type;
uniform mat4 transMat;
uniform mat4 invTransMat;



void main(void)
{
	vec4 position = gl_in[0].gl_Position;
	vec4 mpos;
	mat4 mposInvMat;
	mat4 mposMat;
	float size = params[0].y;
	mat4 moveMatrix;
	vec2 off;
	float shape;
	
	if(type == 1)
	{
		shape = params[0].z;
	}
	if(type == 2)
	{
		float time = updatetime - floor(updatetime);
		time = time;
		shape = floor(time * (m * m));
		//shape = params[0].z;
	}
	
	if(type == 3)
	{
		shape = params[0].z;
		float currPosZ = (mvMat * position).z;
		if(currPosZ > 0) position.z -= (floor(currPosZ/1000)+1) * 1000; //"culling", keep steady amount of particles in z-dir
	}
	if(type == 4)
	{
		shape = params[0].z;

		float time = max(updatetime - shape * 0.04,0.001);
		size = size * 1.5f/time;
	}


	
	mat4 bbRot = mvMat;
	bbRot[0] = vec4(bbRot[0].x, bbRot[0].y, -bbRot[0].z, 0.0);
	bbRot[1] = vec4(bbRot[1].x, bbRot[1].y, -bbRot[1].z, 0.0);
	bbRot[2] = vec4(bbRot[2].x, bbRot[2].y, -bbRot[2].z, 0.0);
	bbRot[3] = vec4(0, 0, 0, 1.0);
	
	mat4 Rotate = mat4(1);


	if(type == 4)
	{
		float angle = 2.35;
		float rotationtime = 1.0;
		float time = clamp(updatetime - shape * 0.04,0,rotationtime);
		angle = time/rotationtime * angle;
		float cosa = cos(angle);
		float sina = sin(angle);
	
		Rotate[0] = vec4(cosa, sina, 0, 0);
		Rotate[1] = vec4(-sina, cosa, 0, 0);
	
		mposInvMat = mat4(1);
		mposMat = mat4(1);
	}	
	
	Rotate = bbRot * Rotate;
	if(type != 3)
	{
		off.x = float(1.0f/m) * float(mod(int(shape), int(m)));
		off.y = float(1.0f/m) * (1 - float(floor(shape/m)));
	}else
	{
		off = vec2(0,-1);
	}
		

	//vec3 tmp = (mvMat * vec4(lightDirection,1)).xyz - (mvMat * position).xyz;

	moveMatrix[0] = vec4(1.0, 0.0, 0.0, 0.0);
	moveMatrix[1] = vec4(0.0, 1.0, 0.0, 0.0);
	moveMatrix[2] = vec4(0.0, 0.0, 1.0, 0.0);
	moveMatrix[3] = vec4(0.0, 0.0, 0.0, 1.0);
	
		
	moveMatrix[3] = vec4(-size/2, -size/2, 0, 1);
	mpos = moveMatrix * position;

	mposInvMat[3] = vec4(-position.x, -position.y, -position.z, 1);
	mposMat[3] = vec4(position.x, position.y, position.z, 1);
	mpos = mposMat * Rotate * mposInvMat * mpos;
	
	gl_Position = projMat * mvMat * mpos;
	texCoords = vec2(0 + off.x, -1*(0 + off.y));
	//normal = normvelo[0];
	//tmp = normalize(tmp);
	//light = tmp;
	fragAlpha = geomAlpha[0];
	EmitVertex();
	
	
	moveMatrix[3] = vec4(size/2, -size/2, 0, 1);
	mpos = moveMatrix * position;

	mposInvMat[3] = vec4(-position.x, -position.y, -position.z, 1);
	mposMat[3] = vec4(position.x, position.y, position.z, 1);
	mpos = mposMat * Rotate * mposInvMat * mpos;
	
	gl_Position = projMat * mvMat * mpos;
	texCoords = vec2(1.0f/m + off.x, -1*(0 + off.y));

	//normal = normvelo[0];
	//light = tmp;
	fragAlpha = geomAlpha[0];
	EmitVertex();
	
	
	moveMatrix[3] = vec4(-size/2, size/2, 0, 1);
	mpos = moveMatrix * position;

	mposInvMat[3] = vec4(-position.x, -position.y, -position.z, 1);
	mposMat[3] = vec4(position.x, position.y, position.z, 1);
	mpos = mposMat * Rotate * mposInvMat * mpos;
	
	gl_Position = projMat * mvMat * mpos;
	texCoords = vec2(0 + off.x, -1*(1.0f/m + off.y));

	//normal = normvelo[0];
	//light = tmp;
	fragAlpha = geomAlpha[0];
	EmitVertex();	
	

	moveMatrix[3] = vec4(size/2, size/2, 0, 1);
	mpos = moveMatrix * position;

	mposInvMat[3] = vec4(-position.x, -position.y, -position.z, 1);
	mposMat[3] = vec4(position.x, position.y, position.z, 1);
	mpos = mposMat * Rotate * mposInvMat * mpos;
	
	gl_Position = projMat * mvMat * mpos;
	texCoords = vec2(1.0f/m + off.x, -1*(1.0f/m + off.y));
	//normal = normvelo[0];
	//light = tmp;
	fragAlpha = geomAlpha[0];
	EmitVertex();
		
	
	EndPrimitive();
    


}
